<template>
  <b-container id="detail-view">
    <!-- Header Buttons -->
    <MetadataManagerHeader
      v-if="resource"
      :current-folder-content="currentFolderContent"
      :editable-data-url="editableDataUrl"
      :is-uploading="isUploading"
      :read-only="readOnly"
      :resource="resource"
      :show-detail="showDetail"
      :shown-files="shownFiles"
      @download="download"
      @downloadExtractedMetadata="downloadExtractedMetadata"
      @downloadMetadata="downloadMetadata"
      @selectFiles="selectFiles"
      @selectFolders="selectFolders"
      @showModalDeleteFolderContents="showModalDeleteFolderContents"
      @copyUrl="copyUrl"
    />

    <!-- Selected Files Table -->
    <MetadataManagerTable
      :current-file-id="currentFileId"
      :current-folder-content="currentFolderContent"
      :editable-data-url="editableDataUrl"
      :editable-key="editableKey"
      :show-detail="showDetail"
      :shown-files="shownFiles"
      @changeMetadata="changeMetadata"
      @loadAllFilesTab="changeMetadata(-1)"
      @removeElement="removeElement"
      @setVersion="setVersion"
    />

    <!-- Metadata Section -->
    <b-row id="metadataManagerMetadataSection">
      <b-col>
        <!-- File Information -->
        <MetadataManagerFileInformation
          v-if="
            showDetail &&
            fileListEdit.length > 0 &&
            currentFileId >= 0 &&
            currentFileId < fileListEdit.length
          "
          :current-file-id="currentFileId"
          :file-list-edit="fileListEdit"
        />
        <!-- Special Properties (see Linked Data) -->
        <MetadataManagerSpecialProperties
          v-if="
            shownFiles.length > 0 &&
            currentFileId >= 0 &&
            resource &&
            currentFolderContent
          "
          :current-folder-content="currentFolderContent"
          :editable-data-url="editableDataUrl"
          :editable-key="editableKey"
          :read-only="readOnly"
          :resource="resource"
          :show-detail="showDetail"
          @updateAbsolutePath="updateAbsolutePath"
          @updateDataUrl="updateDataUrl"
        />
        <MetadataManagerViewSwitch
          v-if="
            shownFiles.length > 0 &&
            currentFileId >= 0 &&
            fileListUpload.length === 0 &&
            resource &&
            resource.metadataExtraction
          "
          :current-view="currentView"
          @switchView="switchView"
        />
        <!-- Form Generator -->
        <span
          v-if="
            resource &&
            resource?.applicationProfile?.uri !== '' &&
            applicationProfile &&
            (currentView === 'Metadata' || fileListUpload.length !== 0)
          "
          class="generatedFormSpan"
        >
          <FormGenerator
            :key="formGeneratorKey"
            class="generatedForm"
            :fixed-values="resource.fixedValues"
            :form-data="currentUsedMetadata"
            :ignore-template-values="resource.metadataExtraction === true"
            :locale="$i18n.locale"
            :selected-shape="resource.applicationProfile?.uri"
            :shapes="applicationProfile"
            :disabled-mode="formGeneratorDisabled"
            :validation-context="currentFileId + ''"
            :class-receiver="getVocabularyInstances"
            :instance-receiver="getVocabularyInstance"
            :user-receiver="async () => user"
            @update:form-data="inputMetadata"
            @isValid="isValid"
            @isValidating="isValidatingChange"
          />
        </span>
        <div
          v-else-if="
            currentView === 'Extracted' &&
            shownFiles.length > 0 &&
            currentFileId >= 0 &&
            fileListUpload.length === 0 &&
            resource &&
            resource.metadataExtraction
          "
        >
          <MetadataManagerExtractedView
            :loading-extracted-metadata="loadingExtractedMetadata"
            :metadata="currentUsedMetadata"
          />
        </div>
      </b-col>
    </b-row>

    <!-- Footer -->
    <MetadataManagerFooter
      :is-uploading="isUploading"
      :number-of-currently-processed-files="numberOfCurrentlyProcessedFiles"
      :progress-status="progressStatus"
      :save-button-disabled="saveButtonDisabled"
      :show-detail="showDetail"
      :total-number-of-currently-processed-files="
        totalNumberOfCurrentlyProcessedFiles
      "
      @update="update"
      @uploadPreparation="uploadPreparation"
    />

    <!-- Validation Popover -->
    <ValidationPopover
      v-if="validationResults[currentFileId + 1] || !isEntryNameUrlSafe"
      :is-entry-name-url-safe="isEntryNameUrlSafe"
      :valid="valid"
      :validation-results="validationResults[currentFileId + 1].results"
    />

    <!-- Duplicate Files Modal -->
    <SaveDuplicateFilesModal
      :visible="saveDuplicateFilesModalVisible"
      :upload-file-list-replace-files="uploadFileListReplaceFiles"
      @close="hideModalSaveDuplicateFiles"
      @skip="skipModalSaveDuplicateFiles"
      @accept="overwriteModalSaveDuplicateFiles"
    />
  </b-container>
</template>

<script lang="ts">
// import the store for current module
import useResourceStore from "../../store";
import useProjectStore from "@/modules/project/store";
import useUserStore from "@/modules/user/store";
import useNotificationStore from "@/store/notification";
import MetadataManagerUtil from "../../utils/MetadataManagerUtil";
import MetadataManagerHeader from "./metadata/MetadataManagerHeader.vue";
import MetadataManagerTable from "./metadata/MetadataManagerTable.vue";
import MetadataManagerFileInformation from "./metadata/MetadataManagerFileInformation.vue";
import MetadataManagerSpecialProperties from "./metadata/MetadataManagerSpecialProperties.vue";
import MetadataManagerFooter from "./metadata/MetadataManagerFooter.vue";
import MetadataManagerViewSwitch from "./metadata/MetadataManagerViewSwitch.vue";
import MetadataManagerExtractedView from "./metadata/MetadataManagerExtractedView.vue";
import SaveDuplicateFilesModal from "./modals/SaveDuplicateFilesModal.vue";
import ValidationPopover from "./popovers/ValidationPopover.vue";
import factory from "rdf-ext";
import { v4 as uuidv4 } from "uuid";
import { serializeRDFDefinition } from "../../utils/linkedData";
import prefixes from "@zazuko/prefixes/prefixes";
import type ValidationReport from "rdf-validate-shacl/src/validation-report";
import type { Dataset, Quad_Subject } from "@rdfjs/types";
import type {
  MetadataTreeForCreationDto,
  MetadataTreeForUpdateDto,
  ProjectDto,
  RdfFormat,
  ResourceDto,
  ResourceTypeInformationDto,
  UserDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type {
  BilingualLabel,
  BilingualLabels,
  FileInformation,
  FolderContent,
  MetadataManagerViews,
} from "../../types";
import type { AxiosProgressEvent } from "axios";
import { validEntryName } from "../../utils/validators";

export default defineComponent({
  components: {
    MetadataManagerHeader,
    MetadataManagerTable,
    MetadataManagerFileInformation,
    MetadataManagerSpecialProperties,
    MetadataManagerFooter,
    MetadataManagerViewSwitch,
    MetadataManagerExtractedView,

    SaveDuplicateFilesModal,
    ValidationPopover,
  },

  props: {
    showDetail: {
      default: false,
      type: Boolean,
    },
    isUploading: {
      default: false,
      type: Boolean,
    },
    fileListEdit: {
      default: () => {
        return [];
      },
      type: Array as PropType<FolderContent[]>,
    },
    fileListUpload: {
      default: () => {
        return [];
      },
      type: Array as PropType<FileInformation[]>,
    },
    folderContents: {
      default: () => {
        return [];
      },
      type: Array as PropType<FolderContent[]>,
    },
    dirTrail: {
      required: true,
      type: String,
    },
    dirCrumbs: {
      required: true,
      type: Array as PropType<string[]>,
    },
  },

  emits: {
    clickFileSelect: () => true,
    clickFolderSelect: () => true,
    emptyFileLists: (_: boolean) => true,
    isUploading: (_: boolean) => true,
    navigateTree: () => true,
    removeElement: (_index: number, _count: number) => true,
    removeSelection: (_index: number, _count: number) => true,
    showModalDelete: (_: FolderContent[]) => true,
  },

  setup() {
    const resourceStore = useResourceStore();
    const projectStore = useProjectStore();
    const userStore = useUserStore();
    const notificationStore = useNotificationStore();

    return {
      resourceStore,
      projectStore,
      userStore,
      notificationStore,
    };
  },

  data() {
    return {
      currentUsedMetadata: factory.dataset() as unknown as Dataset,
      currentView: "Metadata" as MetadataManagerViews,
      loadingExtractedMetadata: false,
      loadingVersionMetadata: false,
      numberOfCurrentlyProcessedFiles: 0,
      totalNumberOfCurrentlyProcessedFiles: 0,
      uploadDuplicates: true,
      currentFileId: -1,
      uploadFileListNewFiles: [] as FileInformation[],
      uploadFileListReplaceFiles: [] as FileInformation[],
      fileListError: [] as FolderContent[],
      progressStatus: 0,
      validationResults: [] as {
        conforms: boolean;
        results: {
          message: string[];
          term: string;
          path: string;
        }[];
      }[],
      isValidating: false,
      storedSwitch: null as number | null,

      saveDuplicateFilesModalVisible: false,
    };
  },

  computed: {
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
    applicationProfile(): Dataset | null {
      return this.resourceStore.currentFullApplicationProfile;
    },
    project(): null | ProjectDto {
      return this.projectStore.currentProject;
    },
    resource(): null | ResourceDto {
      return this.resourceStore.currentResource;
    },
    user(): UserDto {
      return this.userStore.user ?? { displayName: undefined };
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id,
      );
    },
    editableDataUrl(): boolean {
      return (
        this.resourceTypeInformation?.resourceContent?.metadataView
          ?.editableDataUrl === true
      );
    },
    editableKey(): boolean {
      return (
        this.resourceTypeInformation?.resourceContent?.metadataView
          ?.editableKey === true
      );
    },
    readOnly(): boolean {
      return this.resourceTypeInformation?.resourceContent?.readOnly === true;
    },

    currentFolderContent(): FolderContent | undefined {
      return this.shownFiles[this.currentFileId];
    },

    isEntryNameUrlSafe(): boolean {
      return (
        this.currentFolderContent === undefined ||
        validEntryName(this.currentFolderContent.name)
      );
    },

    currentMetadata(): Dataset {
      if (
        this.currentFileId >= 0 &&
        this.currentFileId < this.shownFiles.length
      ) {
        if (this.currentFolderContent && !this.loadingVersionMetadata) {
          const metadata =
            this.currentFolderContent.metadata[this.currentVersion];
          if (metadata) {
            return metadata;
          }
        }
        return factory.dataset() as unknown as Dataset;
      } else {
        return this.metadataTemplate;
      }
    },
    currentExtractedMetadata(): Dataset {
      if (
        this.currentFileId >= 0 &&
        this.currentFileId < this.shownFiles.length &&
        !this.loadingExtractedMetadata
      ) {
        if (
          this.currentFolderContent &&
          this.currentFolderContent.extractedMetadata
        ) {
          const extractedMetadata =
            this.currentFolderContent.extractedMetadata[this.currentVersion];
          if (extractedMetadata) {
            return extractedMetadata;
          }
        }
      }
      return factory.dataset() as unknown as Dataset;
    },
    currentVersion(): number {
      if (this.currentFolderContent) {
        return this.currentFolderContent.currentVersion;
      }
      return 0;
    },
    currentViewedMetadata(): Dataset {
      if (this.currentView === "Extracted") {
        return this.currentExtractedMetadata;
      }
      return this.currentMetadata;
    },
    formGeneratorDisabled(): boolean {
      return (
        this.isGuest ||
        this.resource?.archived ||
        (this.currentFileId !== -1 &&
          this.currentVersion !== this.currentFolderContent?.latestVersion) ||
        this.loadingVersionMetadata
      );
    },
    formGeneratorKey(): string {
      return (
        "" +
        this.showDetail +
        (this.fileListUpload.length !== 0) +
        this.shownFiles.length +
        this.currentFileId +
        (this.currentFolderContent
          ? this.currentFolderContent.name + this.currentFolderContent.id
          : "") +
        this.loadingVersionMetadata +
        this.formGeneratorDisabled
      );
    },
    metadataTemplate(): Dataset {
      if (this.resource && this.resource.applicationProfile) {
        const dataset = factory.dataset();
        dataset.add(
          factory.quad(
            factory.blankNode(),
            factory.namedNode(
              "http://www.w3.org/1999/02/22-rdf-syntax-ns#type",
            ),
            factory.namedNode(this.resource.applicationProfile),
          ),
        );
        return dataset as unknown as Dataset;
      } else {
        return factory.dataset() as unknown as Dataset;
      }
    },
    saveButtonDisabled(): boolean {
      return (
        (this.resource && this.resource.archived) ||
        !this.isEntryNameUrlSafe ||
        !this.valid ||
        this.isUploading ||
        this.currentView === "Extracted" ||
        (this.currentFileId !== -1 &&
          this.currentVersion !== this.currentFolderContent?.latestVersion) ||
        (this.currentFolderContent?.type === "Leaf" &&
          ((this.editableDataUrl && !this.currentFolderContent.dataUrl) ||
            (this.editableKey && !this.currentFolderContent.name)))
      );
    },
    shownFiles(): FolderContent[] {
      let shownFiles: FolderContent[] = [];
      if (this.showDetail) {
        shownFiles = this.fileListEdit;
      } else if (this.fileListUpload.length !== 0) {
        shownFiles = this.fileListUpload;
      }
      return shownFiles;
    },
    valid(): boolean {
      if (!this.validationResults.length) {
        return false;
      }
      if (this.currentFileId === -1) {
        return this.validationResults[0].conforms;
      }
      if (this.validationResults.length < 2) {
        return false;
      }
      return this.validationResults.slice(1).every((entry) => entry.conforms);
    },
  },

  watch: {
    currentVersion() {
      if (this.fileListUpload.length === 0) {
        this.setExtractedMetadata();
      }
    },
    currentViewedMetadata() {
      this.currentUsedMetadata = this.currentViewedMetadata;
    },
    fileListUpload() {
      this.currentView = "Metadata";
      this.getOptions();
    },
    "fileListUpload.length"() {
      this.currentView = "Metadata";
      this.getOptions();
    },
    fileListEdit(newVal: FolderContent[], oldVal: FolderContent[]) {
      // Trigger only the value really changed. Otherwise double API calls are triggered.
      if (newVal !== oldVal && newVal.length !== 0) {
        this.getOptions();
        this.setExtractedMetadata();
      }
      if (newVal.length === 0) {
        this.currentView = "Metadata";
      }
    },
    isValidating() {
      if (!this.isValidating && this.storedSwitch !== null) {
        this.currentFileId = this.storedSwitch;
        this.storedSwitch = null;
      }
    },
    shownFiles() {
      this.validationResults = Array.from(
        { length: this.shownFiles.length + 1 },
        (_) =>
          reactive({
            conforms: false,
            results: [],
          }),
      );
    },
  },

  created() {
    this.getOptions();
  },

  methods: {
    /**
     * Fetches vocabulary instance from the store.
     */
    async getVocabularyInstance(instanceUrl: string): Promise<BilingualLabel> {
      return await this.resourceStore.getVocabularyInstance(instanceUrl);
    },

    /**
     * Fetches vocabulary instances for a given class name from the store.
     *
     * @async
     * @param {string} className - The class name for which vocabulary instances need to be fetched.
     * @param {number} pageNumber - The pageNumber for retrieving the correct page of files.
     * @param {number} pageSize - The pageSize for retrieving the correct size of the files.
     * @returns {Promise<BilingualLabels>} Returns a promise resolving to bilingual labels.
     */
    async getVocabularyInstances(
      className: string,
      pageNumber: number,
      pageSize: number,
      searchTerm?: string | undefined,
    ): Promise<BilingualLabels> {
      return await this.resourceStore.getVocabularyInstances(
        className,
        pageNumber,
        pageSize,
        searchTerm,
      );
    },

    /**
     * Applies metadata templates to the shown files.
     */
    applyMetadataTemplate() {
      if (this.currentUsedMetadata && this.currentUsedMetadata.size > 0) {
        for (const currentFile of this.shownFiles) {
          currentFile.metadata[currentFile.latestVersion] = factory.dataset(
            Array.from(this.currentUsedMetadata),
          ) as unknown as Dataset;
        }
      }
    },

    /**
     * Gets the name of a property in the application profile.
     *
     * @param {Quad_Subject} path - The path in the application profile.
     */
    getPropertyName(path: Quad_Subject) {
      if (this.applicationProfile) {
        for (const match of this.applicationProfile.match(
          null,
          factory.namedNode(prefixes.sh + "path"),
          path,
        )) {
          const entries = Array.from(
            this.applicationProfile.match(
              match.subject,
              factory.namedNode(prefixes.sh + "name"),
            ),
          );
          for (const entry of entries) {
            const obj = entry.object;
            if (obj.termType === "Literal") {
              if (!obj.language || obj.language === this.$i18n.locale) {
                return obj.value;
              }
            }
          }
          // No fitting locale provided
          if (entries.length > 0) {
            return entries[0].object.value;
          }
        }
      }
      return null;
    },

    /**
     * Validates a file based on provided validation results.
     *
     * @param {ValidationReport} valid - The validation report.
     * @param {string} fileString - The file string which will be converted to a number to identify the file.
     */
    isValid(valid: ValidationReport, fileString: string) {
      let fileId = Number(fileString);
      if (isNaN(fileId)) {
        fileId = this.currentFileId;
      }
      if (this.validationResults.length && this.validationResults[fileId + 1]) {
        this.validationResults[fileId + 1].conforms = valid.conforms;
        this.validationResults[fileId + 1].results = valid.results.map(
          (result) => {
            return {
              path: result.path
                ? this.getPropertyName(result.path) ?? result.path.value
                : "",
              term: result.term ? result.term.value : "",
              message: result.message.map((entry) => entry.value),
            };
          },
        );
      }
    },

    /**
     * Updates the validation status.
     *
     * @param {boolean} isValidating - The current validation status.
     * @param {string} _ - Placeholder for an unused parameter.
     */
    isValidatingChange(isValidating: boolean, _: string) {
      this.isValidating = isValidating;
    },

    /**
     * Changes the currently viewed metadata based on the provided index.
     *
     * @param {number} index - The index of the file whose metadata is to be viewed.
     */
    changeMetadata(index: number) {
      if (this.isValidating) {
        this.storedSwitch = index;
      } else {
        this.currentFileId = index;
      }
      // Ensure that all files always shows the metadata view
      if (index === -1) {
        this.currentView = "Metadata";
      }
    },

    /**
     * Removes elements from the list based on the provided index and count.
     *
     * @param {number} index - The starting index for the removal.
     * @param {number} count - The number of elements to be removed.
     */
    removeElement(index: number, count = 1) {
      if (this.showDetail) {
        this.$emit("removeSelection", index, count);
      } else {
        this.$emit("removeElement", index, count);
      }
    },

    /**
     * Adjusts the status of processed files. Sends notifications if necessary.
     *
     * @param {FolderContent} file - The file whose status needs adjustment.
     * @param {boolean} error - A flag indicating if there was an error processing the file.
     * @param {boolean} reload - A flag indicating if the page should reload.
     */
    adjustRemainingFiles(file: FolderContent, error = false, reload = false) {
      this.numberOfCurrentlyProcessedFiles -= 1;
      this.progressStatus = 0;
      if (file.type === "Leaf") {
        file.uploading = false;
      }
      if (error) {
        this.fileListError.push(file);
      }
      if (this.numberOfCurrentlyProcessedFiles === 0) {
        this.uploadDuplicates = true;
        this.$emit("isUploading", false);

        this.cleanup();

        if (reload) {
          location.reload();
        } else {
          const numberOfSuccessfulUploadedFiles =
            this.totalNumberOfCurrentlyProcessedFiles -
            this.fileListError.length;
          /*
          // Currently broken, commenting out for now (see https://git.rwth-aachen.de/coscine/issues/-/issues/2783#note_2468820)
          
          if (this.fileListError.length > 0) {
            const h = this.$createElement;
            const content = [];
            content.push(
              this.$t("page.resource.toastSavingFailedBodyTop").toString(),
            );
            content.push(h("br"));

            for (const fileWithError of this.fileListError) {
              content.push("" + fileWithError.name);
              content.push(h("br"));
            }

            content.push(
              this.$t("page.resource.toastSavingFailedBodyBottom").toString(),
            );

            const vNodesMsg = h("span", {}, content);
            this.notificationStore.postNotification({
              title: this.$t("page.resource.toastSavingFailedTitle").toString(),
              body: vNodesMsg,
              variant: "warning",
            });
          }*/
          if (numberOfSuccessfulUploadedFiles > 0) {
            this.notificationStore.postNotification({
              title: this.$t(
                "page.resource.toastSavingSuccessfulTitle",
              ).toString(),
              body: this.$t("page.resource.toastSavingSuccessfulBody", {
                number: numberOfSuccessfulUploadedFiles,
              }).toString(),
            });
          }
        }
      }
    },

    /**
     * Initializes the count of remaining files to be processed.
     *
     * @param {number} numberOfFiles - The initial number of files to be processed.
     */
    initRemainingFiles(numberOfFiles: number) {
      this.fileListError = [];
      this.numberOfCurrentlyProcessedFiles = numberOfFiles;
      this.totalNumberOfCurrentlyProcessedFiles = numberOfFiles;
      for (const currentFile of this.shownFiles) {
        if (
          (this.uploadDuplicates ||
            this.folderContents.find((x) => x.path === currentFile.path) ===
              undefined) &&
          currentFile.type === "Leaf"
        ) {
          currentFile.uploading = true;
        }
      }
      if (this.numberOfCurrentlyProcessedFiles > 0) {
        this.$emit("isUploading", true);
      }
    },

    /**
     * Updates the metadata for the current folder content and sets the current metadata.
     *
     * @param {Dataset} metadata - The metadata to be set.
     */
    inputMetadata(metadata: Dataset) {
      if (
        this.currentFolderContent &&
        this.currentFolderContent.currentVersion ===
          this.currentFolderContent.latestVersion
      ) {
        this.currentFolderContent.metadata[
          this.currentFolderContent.currentVersion
        ] = metadata;
      }
      this.currentUsedMetadata = metadata;
    },

    /**
     * Prepares for file uploads by segregating new files and replacement files.
     *
     * @async
     */
    async uploadPreparation() {
      this.uploadFileListNewFiles = [];
      this.uploadFileListReplaceFiles = [];
      for (const fileToUpload of this.fileListUpload) {
        if (
          this.folderContents.find((x) => x.path === fileToUpload.path) ===
          undefined
        ) {
          this.uploadFileListNewFiles.push(fileToUpload);
        } else {
          this.uploadFileListReplaceFiles.push(fileToUpload);
        }
      }
      if (this.uploadFileListReplaceFiles.length > 0) {
        this.showModalSaveDuplicateFiles();
      } else {
        await this.upload();
      }
    },

    /**
     * Starts the file upload process.
     *
     * @async
     */
    async upload() {
      if (this.currentFileId === -1) {
        this.applyMetadataTemplate();
      }
      if (this.uploadDuplicates) {
        this.initRemainingFiles(this.fileListUpload.length);
        for (const fileToUpload of this.fileListUpload) {
          await this.uploadFile(fileToUpload);
        }
      } else {
        this.initRemainingFiles(this.uploadFileListNewFiles.length);
        for (const fileToUpload of this.uploadFileListNewFiles) {
          await this.uploadFile(fileToUpload);
        }
      }
    },

    /**
     * Asynchronously uploads a file and its metadata.
     * It first constructs and serializes a metadata tree DTO for the file, and then
     * attempts to create this metadata tree. If successful, the function uploads the file's content.
     *
     * @param {FileInformation} file - The file information object to be uploaded.
     * @async
     */
    async uploadFile(file: FileInformation) {
      if (!this.project?.id || !this.resource?.id) {
        return;
      }

      // Specify the target content type
      const contentType = "text/turtle";

      // Create the metadata tree DTO and serialize the definition
      const metadataTreeForCreationDto: MetadataTreeForCreationDto = {
        path: file.path,
        definition: {
          content: await serializeRDFDefinition(
            file.metadata[file.latestVersion],
            contentType,
          ),
          type: contentType as RdfFormat,
        },
      };

      // Trigger metadata tree creation. Metadata might be already present, so we try updating it if true.
      const success = await this.resourceStore.addOrUpdateMetadataTree(
        this.project.id,
        this.resource.id,
        metadataTreeForCreationDto,
      );

      if (success) {
        // Check if the file is not editable via data URL and has info, and if so, handle its content upload
        if (!this.editableDataUrl && file.info) {
          await this.handleUploadContent(file.info, file);
        }
        // Else, if the file has a data URL, convert it to a file and handle its content upload
        else if (file.dataUrl !== undefined) {
          this.fillData(file);
          const dataUrlFile = new File([file.dataUrl], file.name, {
            type: "plain/text",
          });
          await this.handleUploadContent(dataUrlFile, file);
        }
      } else {
        // On Failure, post a generic warning notification
        this.notificationStore.postNotification({
          title: this.$t("toast.apiError.general.title").toString(),
          body: this.$t("toast.apiError.general.body").toString(),
          variant: "warning",
        });
        // If metadata tree creation was not successful, adjust the count of files remaining
        this.adjustRemainingFiles(file, true);
      }
    },

    /**
     * Converts a FileInformation's dataUrl into a File object.
     * If no dataUrl exists, initializes it as an empty string.
     *
     * @param {FileInformation} file - The file information to process.
     */
    fillData(file: FileInformation) {
      if (!file.dataUrl) {
        file.dataUrl = "";
      }
      file.info = new File([file.dataUrl], file.name, {
        type: "text/plain",
      });
    },

    /**
     * Handles the uploading of file contents.
     * Depending on whether the file already exists, either updates or creates a new blob.
     * Emits updated folder contents if necessary.
     *
     * @param {File} contents - The file contents to upload.
     * @param {FileInformation} file - The file information.
     * @async
     */
    async handleUploadContent(contents: File, file: FileInformation) {
      if (this.project?.id && this.resource?.id) {
        const fileExists = this.folderContents.some(
          (x) => x.path === file.path,
        );
        this.progressStatus = 0;

        // Update progress as the file is uploaded
        const onUploadProgress = (progressEvent: AxiosProgressEvent) => {
          this.progressStatus = Math.round(
            (progressEvent.loaded * 100) /
              (progressEvent.total ?? Number.MAX_VALUE),
          );
        };

        // Depending on the file's existence, either update or create the blob
        const uploadResult = fileExists
          ? await this.resourceStore.updateBlob(
              this.project.id,
              this.resource.id,
              file.path,
              contents,
              { onUploadProgress },
            )
          : await this.resourceStore.createBlob(
              this.project.id,
              this.resource.id,
              file.path,
              contents,
              { onUploadProgress },
            );

        if (!uploadResult) {
          this.adjustRemainingFiles(file, true);
        }
      }

      // Update or emit the updated folder contents
      const entry = this.folderContents.find((x) => x.path === file.path);
      if (entry === undefined) {
        const identifier = uuidv4();
        const version = +new Date();
        const newRow: FileInformation = {
          id: identifier,
          name: file.name,
          type: file.type,
          parentDirectory: file.parentDirectory,
          lastModified: new Date().toString(),
          createdAt: new Date().toString(),
          size: file.size,
          path: file.path,
          info: file.info,
          versions: [version],
          latestVersion: version,
          currentVersion: version,
          metadata: { [version]: factory.dataset() as unknown as Dataset },
        };
        MetadataManagerUtil.copyMetadata(
          file.metadata[file.latestVersion],
          newRow,
        );
        this.$emit("navigateTree");
      } else {
        entry.lastModified = new Date().toString();
        entry.createdAt = new Date().toString();
        if (entry.type === "Leaf") {
          entry.size = file.size;
        }
        MetadataManagerUtil.copyMetadata(
          file.metadata[file.latestVersion],
          entry,
        );
      }
      this.adjustRemainingFiles(file);
    },

    /**
     * Asynchronously creates the download url for sharing.
     * @async
     */
    async copyUrl() {
      if (
        this.showDetail &&
        this.project?.id &&
        this.resource?.id &&
        this.currentFolderContent
      ) {
        const downloadUrl = await this.resourceStore.getDownloadUrl(
          this.project.id,
          this.resource.id,
          this.currentFolderContent.path,
          this.currentFolderContent.name,
          this.currentFolderContent.actions,
        );

        if (downloadUrl) {
          navigator.clipboard.writeText(downloadUrl);
          this.notificationStore.postNotification({
            title: this.$t("page.resource.toClipboard").toString(),
            body: this.$t("page.resource.expirationMessage").toString(),
          });
        }
      }
    },

    /**
     * Downloads selected file or all files when all files is selected.
     * @async
     */
    async download() {
      const downloadFiles: FolderContent[] = [];
      if (this.currentFolderContent) {
        downloadFiles.push(this.currentFolderContent);
      } else {
        downloadFiles.push(...this.shownFiles);
      }
      for (const downloadFile of downloadFiles) {
        if (this.showDetail && this.project?.id && this.resource?.id) {
          await this.resourceStore.download(
            this.project.id,
            this.resource.id,
            downloadFile.path,
            downloadFile.name,
            downloadFile.actions,
          );
        }
      }
    },

    /**
     * Downloads selected metadata.
     *
     * @async
     */
    async downloadMetadata() {
      await this.resourceStore.triggerMetadataDownload(this.currentMetadata);
    },

    /**
     * Downloads selected extracted metadata.
     *
     * @async
     */
    async downloadExtractedMetadata() {
      await this.setExtractedMetadata(true);
      if (this.currentExtractedMetadata.size > 0) {
        await this.resourceStore.triggerMetadataDownload(
          this.currentExtractedMetadata,
          "extractedMetadata.ttl",
        );
      } else {
        // If no extracted metadata exists, post an error
        this.notificationStore.postNotification({
          title: this.$t(
            "page.resource.toast.noExtractedMetadata.title",
          ).toString(),
          body: this.$t(
            "page.resource.toast.noExtractedMetadata.body",
          ).toString(),
          variant: "warning",
        });
      }
    },

    /**
     * Emits an event signaling the selection of files.
     */
    selectFiles() {
      this.$emit("clickFileSelect");
    },

    /**
     * Emits an event signaling the selection of folder.
     */
    selectFolders() {
      this.$emit("clickFolderSelect");
    },

    /**
     * Retrieves the current extracted metadata.
     *
     * @async
     */
    async setExtractedMetadata(force: boolean = false) {
      if (
        (this.currentView === "Extracted" || force) &&
        this.currentFolderContent &&
        (!this.currentFolderContent.extractedMetadata ||
          !this.currentFolderContent.extractedMetadata[this.currentVersion]) &&
        this.project &&
        this.project.id &&
        this.resource &&
        this.resource.id
      ) {
        this.loadingExtractedMetadata = true;
        if (!this.currentFolderContent.extractedMetadata) {
          this.currentFolderContent.extractedMetadata = {};
        }
        this.currentFolderContent.extractedMetadata[this.currentVersion] =
          (await this.resourceStore.getExtractedMetadata(
            this.project.id,
            this.resource.id,
            this.currentFolderContent.path,
            this.currentVersion,
          )) ?? (factory.dataset() as unknown as Dataset);
        this.loadingExtractedMetadata = false;
      }
    },

    /**
     * Switches between normal metadata & extraction view.
     *
     * @async
     */
    async switchView(newView: MetadataManagerViews) {
      this.currentView = newView;
      await this.setExtractedMetadata();
    },

    /**
     * Asynchronously updates the resource's metadata based on the files in the edit list.
     * It applies metadata templates, initializes remaining files, and then iterates over
     * the edit list to update each file's metadata. It also handles file uploads when
     * necessary.
     *
     * @async
     */
    async update() {
      if (!this.project?.id || !this.resource?.id) {
        return;
      }

      // Specify the target content type
      const contentType = "text/turtle";

      // If this is the initial file, apply the metadata template
      if (this.currentFileId === -1) {
        this.applyMetadataTemplate();
      }

      // Initialize files yet to be processed
      this.initRemainingFiles(this.fileListEdit.length);

      for (const file of this.fileListEdit) {
        // Create the metadata tree DTO and serialize the definition
        const metadataTreeForUpdateDto: MetadataTreeForUpdateDto = {
          path: file.path,
          definition: {
            content: await serializeRDFDefinition(
              file.metadata[file.latestVersion],
              contentType,
            ),
            type: contentType as RdfFormat,
          },
        };

        const success = await this.resourceStore.updateOrAddMetadataTree(
          this.project.id,
          this.resource.id,
          metadataTreeForUpdateDto,
        );

        if (success) {
          // Get new version
          const newMetadataVersion =
            await this.resourceStore.getCurrentMetadataVersion(
              this.project.id,
              this.resource.id,
              file.path,
            );

          if (newMetadataVersion && newMetadataVersion.response.version) {
            const newVersion = Number(newMetadataVersion.response.version);
            file.metadata[newVersion] = newMetadataVersion.dataset;
            delete file.metadata[file.latestVersion];
            file.latestVersion = newVersion;
            file.currentVersion = newVersion;
            file.versions.push(newVersion);
          }

          // Find the corresponding file entry from folder contents
          const tmp = this.folderContents.find((x) => x.path === file.path);

          // If the file has a data URL and is editable, handle its content upload
          if (
            this.editableDataUrl &&
            file.type === "Leaf" &&
            file.dataUrl !== undefined
          ) {
            this.fillData(file);
            const dataUrlFile = new File([file.dataUrl], file.name, {
              type: "plain/text",
            });
            await this.handleUploadContent(dataUrlFile, file);
          } else {
            // If not a file for upload, just copy the metadata
            MetadataManagerUtil.copyMetadata(
              file.metadata[file.latestVersion],
              tmp,
            );
            this.adjustRemainingFiles(file);
          }
        } else {
          // If the update was not successful, adjust the remaining files count
          this.adjustRemainingFiles(file, true);
        }
      }
    },

    /**
     * Retrieves blob options for each shown file, if applicable.
     * Updates the data URL for each file from the store.
     *
     * @async
     */
    async getOptions() {
      if (this.shownFiles.length === 1) {
        this.currentFileId = 0;
      }
      if (this.editableDataUrl) {
        if (this.project?.id && this.resource?.id) {
          for (const file of this.shownFiles) {
            const element = file;
            if (element.type === "Leaf") {
              if (element.requesting || element.path === "") {
                return;
              }
              element.requesting = true;
              const response = await this.resourceStore.getBlob(
                this.project.id,
                this.resource.id,
                element.path,
              );
              if (response !== null) {
                // TODO: Check if reactivity still works
                element.dataUrl = response.data as unknown as string;
              }
              element.requesting = false;
            }
          }
        }
      }
    },

    /**
     * Updates the absolute path of the current folder content based on a new value.
     *
     * @param {string} value - The new value for the folder content's name.
     */
    updateAbsolutePath(value: string) {
      if (this.currentFolderContent) {
        this.currentFolderContent.name = value;
        const currentFolder = this.dirCrumbs.join("");
        this.currentFolderContent.path =
          currentFolder + this.currentFolderContent.name;
      }
    },

    /**
     * Updates the data URL and size of the current folder content based on a new value.
     *
     * @param {string} value - The new value for the data URL.
     */
    updateDataUrl(value: string) {
      if (
        this.currentFolderContent &&
        this.currentFolderContent.type === "Leaf"
      ) {
        this.currentFolderContent.dataUrl = value;
        this.currentFolderContent.size = value.length;
      }
    },

    /**
     * Sets the current displayed metadata version for data.
     */
    async setVersion(version: number) {
      if (this.currentFolderContent) {
        this.currentFolderContent.currentVersion = version;
        if (
          this.currentFolderContent &&
          !this.currentFolderContent.metadata[version] &&
          this.project &&
          this.project.id &&
          this.resource &&
          this.resource.id
        ) {
          this.loadingVersionMetadata = true;
          if (!this.currentFolderContent.metadata) {
            this.currentFolderContent.metadata = {};
          }
          this.currentFolderContent.metadata[version] =
            (await this.resourceStore.getMetadataVersion(
              this.project.id,
              this.resource.id,
              this.currentFolderContent.path,
              version,
            )) ?? (factory.dataset() as unknown as Dataset);
          this.loadingVersionMetadata = false;
        }
      }
    },

    /**
     * Emits an event to clean up file lists.
     */
    cleanup() {
      this.$emit("emptyFileLists", true);
    },
    /**
     * Emits an event to display the modal for deleting folder contents.
     */
    showModalDeleteFolderContents() {
      const deleteList: FolderContent[] = [];
      if (this.currentFolderContent) {
        deleteList.push(this.currentFolderContent);
      } else {
        deleteList.push(...this.shownFiles);
      }
      this.$emit("showModalDelete", deleteList);
    },

    /**
     * Displays the modal for saving duplicate files.
     */
    showModalSaveDuplicateFiles() {
      this.saveDuplicateFilesModalVisible = true;
    },

    /**
     * Hides the modal for saving duplicate files.
     */
    hideModalSaveDuplicateFiles() {
      this.saveDuplicateFilesModalVisible = false;
    },

    /**
     * Handles the overwrite action in the modal for saving duplicate files.
     * Initiates the upload process afterward.
     */
    overwriteModalSaveDuplicateFiles() {
      this.uploadDuplicates = true;
      this.saveDuplicateFilesModalVisible = false;
      this.upload();
    },

    /**
     * Handles the skip action in the modal for saving duplicate files.
     * Initiates the upload process afterward.
     */
    skipModalSaveDuplicateFiles() {
      this.uploadDuplicates = false;
      this.saveDuplicateFilesModalVisible = false;
      this.upload();
    },
  },
});
</script>

<style scoped>
.generatedForm {
  margin-top: 10px;
}
#detail-view {
  flex-direction: column;
  display: flex;
  max-height: 100%;
}
#metadataManagerMetadataSection {
  overflow-x: hidden;
  overflow-y: auto;
  margin-bottom: 42px;
  padding-right: 0px;
  margin-right: 20px;
}
#metadataManagerMetadataSection :deep(.generatedFormSpan) {
  width: 100%;
}
#metadataManagerMetadataSection :deep(.generatedForm) {
  width: 100%;
  margin-bottom: 200px;
}
#URLBtn {
  min-width: 0px;
}
#progressContainer {
  margin: 0 auto;
}
</style>
